---
title: Redirections in HTTP
slug: Web/HTTP/Redirections
tags:
  - Guide
  - HTTP
  - redirects
---
<div>{{HTTPSidebar}}</div>

<p class="summary"><span class="seoSummary"><em>URL redirection</em>, also known as<em> URL forwarding</em>, is a technique to give more than one URL address to a page, a form, or a whole Web site/application. HTTP has a special kind of response, called a <strong><em>HTTP redirect</em></strong>, for this operation.</span></p>

<p>Redirects accomplish numerous goals:</p>

<ul>
 <li>Temporary redirects during site maintenance or downtime</li>
 <li>Permanent redirects to preserve existing links/bookmarks after changing the site's URLs, progress pages when uploading a file, etc.</li>
</ul>

<h2 id="Principle">Principle</h2>

<p>In HTTP, redirection is triggered by a server sending a special <em>redirect</em> response to a request. Redirect responses have <a href="/en-US/docs/Web/HTTP/Status">status codes</a> that start with <code>3</code>, and a {{ httpheader("Location") }} header holding the URL to redirect to.</p>

<p>When browsers receive a redirect, they immediately load the new URL provided in the <code>Location</code> header. Besides the small performance hit of an additional round-trip, users rarely notice the redirection.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13785/HTTPRedirect.png"></p>

<p>There are several types of redirects, sorted into three categories:</p>

<ol>
 <li><a href="#Permanent_redirections">Permanent redirections</a></li>
 <li><a href="#Temporary_redirections">Temporary redirections</a></li>
 <li><a href="#Special_redirections">Special redirections</a></li>
</ol>

<h3 id="Permanent_redirections">Permanent redirections</h3>

<p>These redirections are meant to last forever. They imply that the original URL should no longer be used, and replaced with the new one.Search engine robots, RSS readers, and other crawlers will update the original URL for the resource.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="row">Code</th>
   <th scope="col">Text</th>
   <th scope="col">Method handling</th>
   <th scope="col">Typical use case</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <th scope="row"><code>301</code></th>
   <td><code>Moved Permanently</code></td>
   <td>{{HTTPMethod("GET")}} methods unchanged.<br>
    Others may or may not be changed to {{HTTPMethod("GET")}}.<sup><a href="#attr1">[1]</a></sup></td>
   <td>Reorganization of a Web site.</td>
  </tr>
  <tr>
   <th scope="row"><code>308</code></th>
   <td><code>Permanent Redirect</code></td>
   <td>Method and body not changed.</td>
   <td>Reorganization of a Web site, with non-GET links/operations.</td>
  </tr>
 </tbody>
</table>

<p id="attr1">[1] The specification did not intend to allow method changes, but there are existing user agents that do change their method. {{HTTPStatus("308")}} was created to remove the ambiguity of the behavior when using non-<code>GET</code> methods.</p>

<h3 id="Temporary_redirections">Temporary redirections</h3>

<p>Sometimes the requested resource can't be accessed from its canonical location, but it can be accessed from another place. In this case, a temporary redirect can be used.</p>

<p>Search engine robots and other crawlers don't memorize the new, temporary URL. Temporary redirections are also used when creating, updating, or deleting resources, to show temporary progress pages.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="row">Code</th>
   <th scope="col">Text</th>
   <th scope="col">Method handling</th>
   <th scope="col">Typical use case</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <th scope="row"><code>302</code></th>
   <td><code>Found</code></td>
   <td>{{HTTPMethod("GET")}} methods unchanged.<br>
    Others may or may not be changed to {{HTTPMethod("GET")}}.<sup><a href="#attr2">[2]</a></sup></td>
   <td>The Web page is temporarily unavailable for unforeseen reasons.</td>
  </tr>
  <tr>
   <th scope="row"><code>303</code></th>
   <td><code>See Other</code></td>
   <td>{{HTTPMethod("GET")}} methods unchanged.<br>
    Others <em>changed</em> to <code>GET</code> (body lost).</td>
   <td>Used to redirect after a {{HTTPMethod("PUT")}} or a {{HTTPMethod("POST")}}, so that refreshing the result page doesn't re-trigger the operation.</td>
  </tr>
  <tr>
   <th scope="row"><code>307</code></th>
   <td><code>Temporary Redirect</code></td>
   <td>Method and body not changed</td>
   <td>The Web page is temporarily unavailable for unforeseen reasons. Better than <code>302</code> when non-<code>GET</code> operations are available on the site.</td>
  </tr>
 </tbody>
</table>

<p id="attr2">[2] The specification did not intend to allow method changes, but there are existing user agents that do change their method. {{HTTPStatus("307")}} was created to remove the ambiguity of the behavior when using non-<code>GET</code> methods.</p>

<h3 id="Special_redirections">Special redirections</h3>

<p>{{HTTPStatus("304")}} (Not Modified) redirects a page to the locally cached copy (that was stale), and {{HTTPStatus("300")}} (Multiple Choice) is a manual redirection: the body, presented by the browser as a Web page, lists the possible redirections and the user clicks on one to select it.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="row">Code</th>
   <th scope="col">Text</th>
   <th scope="col">Typical use case</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <th scope="row"><code>300</code></th>
   <td><code>Multiple Choice</code></td>
   <td>Not many: the choices are listed in an HTML page in the body. Machine-readable choices are encouraged to be sent as {{HTTPHeader("Link")}} headers with <code>rel=alternate</code>.</td>
  </tr>
  <tr>
   <th scope="row"><code>304</code></th>
   <td><code>Not Modified</code></td>
   <td>Sent for revalidated conditional requests. Indicates that the cached response is still fresh and can be used.</td>
  </tr>
 </tbody>
</table>

<h2 id="Alternative_way_of_specifying_redirections">Alternative way of specifying redirections</h2>

<p>HTTP redirects aren't the only way to define redirections. There are two others:</p>

<ol>
 <li>HTML redirections with the {{HTMLElement("meta")}} element</li>
 <li>JavaScript redirections via the <a href="/en-US/docs/Web/API/Document_Object_Model">DOM</a></li>
</ol>

<h3 id="HTML_redirections">HTML redirections</h3>

<p>HTTP redirects are the best way to create redirections, but sometimes you don't have control over the server. In that case, try a {{HTMLElement("meta")}} element with its {{htmlattrxref("http-equiv", "meta")}} attribute set to <code>Refresh</code> in the {{HTMLElement("head")}} of the page. When displaying the page, the browser will go to the indicated URL.</p>

<pre class="brush: html notranslate">&lt;head&gt;
  &lt;meta http-equiv="Refresh" content="0; URL=https://example.com/"&gt;
&lt;/head&gt;
</pre>

<p>The {{htmlattrxref("content")}} attribute should start with a number indicating how many seconds the browser should wait before redirecting to the given URL. Always set it to <code>0</code> for accessibility compliance.</p>

<p>Obviously, this method only works with HTML, and cannot be used for images or other types of content.</p>

<h3 id="JavaScript_redirections">JavaScript redirections</h3>

<p>Redirections in JavaScript are performed by setting a URL string to the {{domxref("window.location")}} property, loading the new page:</p>

<pre class="brush: js notranslate">window.location = "https://example.com/";</pre>

<p>Like HTML redirections, this can't work on all resources, and obviously, this will only work on clients that execute JavaScript. On the other hand, there are more possibilities: for example, you can trigger the redirect only if some conditions are met.</p>

<h3 id="Order_of_precedence">Order of precedence</h3>

<p>With three ways to trigger redirections, several ways can be used at the same time. But which is applied first?</p>

<ol>
 <li>HTTP redirects always execute first — they exist when there is not even a transmitted page.</li>
 <li>HTML redirects ({{HTMLElement("meta")}}) execute if there weren't any HTTP redirects.</li>
 <li>JavaScript redirects execute last, and only if JavaScript is enabled.</li>
</ol>

<p>When possible, use HTTP redirects and don't add {{HTMLElement("meta")}} element redirects. If someone changes the HTTP redirects but forgets to change the HTML redirects, the redirects will no longer be identical, which could cause an infinite loop or other nightmares.</p>

<h2 id="Use_cases">Use cases</h2>

<p>There are numerous use cases for redirects, but as performance is impacted with every redirect, their use should be kept to a minimum.</p>

<h3 id="Domain_aliasing">Domain aliasing</h3>

<p>Ideally, there is one location, and therefore one URL, for each resource. But there are reasons for alternative names for a resource:</p>

<dl>
 <dt>Expanding the reach of your site</dt>
 <dd>A common case is when a site resides at <code>www.example.com</code>, but accessing it from <code>example.com</code> should also work. Redirections for <code>example.com</code> to <code>www.example.com</code> are thus set up. You might also redirect from common synonyms or frequent typos of your domains.</dd>
 <dt>Moving to a new domain</dt>
 <dd>For example, your company was renamed, but you want existing links or bookmarks to still find you under the new name.</dd>
 <dt>Forcing <a href="/en-US/docs/Glossary/https">HTTPS</a></dt>
 <dd>Requests to the <code>http://</code> version of your site will redirect to the <code>https://</code> version of your site.</dd>
</dl>

<h3 id="Keeping_links_alive">Keeping links alive</h3>

<p>When you restructure Web sites, URLs change. Even if you update your site's links to match the new URLs, you have no control over the URLs used by external resources.</p>

<p>You don't want to break these links, as they bring valuable users and help your SEO, so you set up redirects from the old URLs to the new ones.</p>

<div class="note">
<p>This technique does work for internal links, but try to avoid having internal redirects. A redirect has a significant performance cost (as an extra HTTP request occurs). If you can avoid it by correcting internal links, you should fix those links instead.</p>
</div>

<h3 id="Temporary_responses_to_unsafe_requests">Temporary responses to unsafe requests</h3>

<p>{{Glossary("safe", "Unsafe")}} requests modify the state of the server and the user shouldn't resend them unintentionally.</p>

<p>Typically, you don't want your users to resend {{HTTPMethod("PUT")}}, {{HTTPMethod("POST")}} or {{HTTPMethod("DELETE")}} requests. If you serve the response as the result of this request, a simple press of the reload button will resend the request (possibly after a confirmation message).</p>

<p>In this case, the server can send back a {{HTTPStatus("303")}} (See Other) response for a URL that will contain the right information. If the reload button is pressed, only that page is redisplayed, without replaying the unsafe requests.</p>

<h3 id="Temporary_responses_to_long_requests">Temporary responses to long requests</h3>

<p>Some requests may need more time on the server, like {{HTTPHeader("DELETE")}} requests that are scheduled for later processing. In this case, the response is a {{HTTPStatus("303")}} (See Other) redirect that links to a page indicating that the action has been scheduled, and eventually informs about its progress, or allows to cancel it.</p>

<h2 id="Configuring_redirects_in_common_servers">Configuring redirects in common servers</h2>

<h3 id="Apache">Apache</h3>

<p>Redirects can be set either in the server config file or in the <code>.htaccess</code> of each directory.</p>

<p>The <code><a href="https://httpd.apache.org/docs/current/mod/mod_alias.html">mod_alias</a></code> module has <code>Redirect</code> and <code>RedirectMatch</code> directives that set up {{HTTPStatus("302")}} redirects by default:</p>

<pre class="notranslate">&lt;VirtualHost *:443&gt;
	ServerName example.com
	Redirect / https://www.example.com
&lt;/VirtualHost&gt;
</pre>

<p>The URL <code>https://example.com/</code> will be redirected to <code>https://www.example.com/</code>, as will any files or directories under it (<code>https://example.com/some-page</code> will be redirected to <code>https://www.example.com/some-page</code>)</p>

<p><code>RedirectMatch</code> does the same, but takes a {{glossary("regular expression")}} to define a collection of affected URLs:</p>

<pre class="notranslate">RedirectMatch ^/images/(.*)$ https://images.example.com/$1</pre>

<p>All documents in the <code>images/</code> directory will redirect to a different domain.</p>

<p>If you don't want a temporary redirect, an extra parameter (either the HTTP status code to use or the <code>permanent</code> keyword) can be used to set up a different redirect:</p>

<pre class="notranslate">Redirect permanent / https://www.example.com
# …acts the same as:
Redirect 301 / https://www.example.com
</pre>

<p>The <code><a href="http://httpd.apache.org/docs/current/mod/mod_rewrite.html">mod_rewrite</a></code> module can also create redirects. It is more flexible, but a bit more complex.</p>

<h3 id="Nginx">Nginx</h3>

<p>In Nginx, you create a specific server block for the content you want to redirect:</p>

<pre class="notranslate">server {
	listen 80;
	server_name example.com;
	return 301 $scheme://www.example.com$request_uri;
}</pre>

<p>To apply a redirect to a directory or only certain pages, use the <code>rewrite</code> directive:</p>

<pre class="notranslate">rewrite ^/images/(.*)$ https://images.example.com/$1 redirect;
rewrite ^/images/(.*)$ https://images.example.com/$1 permanent;
</pre>

<h3 id="IIS">IIS</h3>

<p>In IIS, you use the <code><a href="https://www.iis.net/configreference/system.webserver/httpredirect">&lt;httpRedirect&gt;</a></code> element to configure redirections.</p>

<h2 id="Redirection_loops">Redirection loops</h2>

<p>Redirection loops happen when additional redirections follow the one that has already been followed. In other words, there is a loop that will never be finished and no page will ever be found.</p>

<p>Most of the time this is a server problem, and if the server cannot detect it, it will send back a {{HTTPStatus("500")}} <code>Internal Server Error</code>. If you encounter such an error soon after modifying a server configuration, this is likely a redirection loop.</p>

<p>Sometimes, the server won't detect it: a redirection loop can spread over several servers which each don't have the full picture. In this case, browsers will detect it and display an error message. Firefox displays:</p>

<blockquote>
<p>Firefox has detected that the server is redirecting the request for this address in a way that will never complete.</p>
</blockquote>

<p>…while Chrome displays:</p>

<blockquote>
<p>This Webpage has a redirect loop</p>
</blockquote>

<p>In both cases, the user can't do much (unless a corruption is happening on their side, like a mismatch of cache or cookies).</p>

<p>It is important to avoid redirection loops, as they completely break the user experience.</p>
